import { NgZone, QueryList } from '@angular/core';
import * as THREE from 'three';
import { NgtInstancesStore } from '../stores/instances.store';
import { NgtMaterial } from '../three/material';
import { Controller } from './controller';
import * as i0 from "@angular/core";
export declare class NgtContentMaterialController extends Controller {
    #private;
    private instancesStore;
    set materialDirectives(v: QueryList<NgtMaterial>);
    set material(v: string | string[] | THREE.Material | THREE.Material[] | undefined);
    contentMaterialController?: NgtContentMaterialController;
    get material(): string | string[] | THREE.Material | THREE.Material[] | undefined;
    constructor(ngZone: NgZone, instancesStore: NgtInstancesStore);
    construct(): void;
    get controller(): Controller | undefined;
    get props(): string[];
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtContentMaterialController, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtContentMaterialController, "    ngt-mesh,    ngt-instanced-mesh,    ngt-skinned-mesh,    ngt-line,    ngt-line-loop,    ngt-line-segments,    ngt-soba-plane,    ngt-soba-box,    ngt-soba-cylinder,    ngt-soba-cone,    ngt-soba-circle,    ngt-soba-sphere,    ngt-soba-tube,    ngt-soba-torus,    ngt-soba-tetrahedron,    ngt-soba-ring,    ngt-soba-polyhedron,    ngt-soba-octahedron,    ngt-soba-dodecahedron,    ngt-soba-icosahedron,    ngt-soba-extrude,    ngt-soba-lathe,    ngt-soba-torus-knot,    ngt-soba-text,  ", ["ngtContentMaterialController"], { "material": "material"; "contentMaterialController": "contentMaterialController"; }, {}, ["materialDirectives"]>;
}
export declare class NgtContentMaterialControllerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtContentMaterialControllerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtContentMaterialControllerModule, [typeof NgtContentMaterialController], never, [typeof NgtContentMaterialController]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtContentMaterialControllerModule>;
}
export declare const NGT_CONTENT_MATERIAL_WATCHED_CONTROLLER: import("@angular/core").InjectionToken<NgtContentMaterialController>, NGT_CONTENT_MATERIAL_CONTROLLER_PROVIDER: import("@angular/core").Provider[];
