import { AfterContentInit, InjectionToken, NgZone } from '@angular/core';
import * as THREE from 'three';
import { AnyConstructor, AnyExtenderFunction } from '../models';
import { NgtContentGeometryController } from './content-geometry.controller';
import { NgtContentMaterialController } from './content-material.controller';
import { Controller } from './controller';
import { NgtObject3dController } from './object-3d.controller';
import * as i0 from "@angular/core";
export declare const NGT_OBJECT_TYPE: InjectionToken<typeof THREE.Object3D>;
export declare const NGT_OBJECT_POST_INIT: InjectionToken<undefined>;
export declare class NgtMaterialGeometryController extends Controller implements AfterContentInit {
    #private;
    objectController: NgtObject3dController;
    objectType: AnyConstructor<THREE.Object3D>;
    objectPostInit: AnyExtenderFunction<THREE.Object3D> | undefined;
    set meshArgs(v: unknown | unknown[]);
    morphTargetInfluences?: number[];
    morphTargetDictionary?: {
        [key: string]: number;
    };
    constructor(ngZone: NgZone, objectController: NgtObject3dController, objectType: AnyConstructor<THREE.Object3D>, objectPostInit: AnyExtenderFunction<THREE.Object3D> | undefined, contentMaterialController: NgtContentMaterialController, contentGeometryController: NgtContentGeometryController);
    ngAfterContentInit(): void;
    get controller(): Controller | undefined;
    get props(): string[];
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtMaterialGeometryController, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtMaterialGeometryController, "    ngt-mesh,    ngt-instanced-mesh,    ngt-skinned-mesh,    ngt-line,    ngt-line-loop,    ngt-line-segments,  ", ["ngtMaterialGeometryController"], { "morphTargetInfluences": "morphTargetInfluences"; "morphTargetDictionary": "morphTargetDictionary"; }, {}, never>;
}
export declare class NgtMaterialGeometryControllerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtMaterialGeometryControllerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtMaterialGeometryControllerModule, [typeof NgtMaterialGeometryController], never, [typeof NgtMaterialGeometryController]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtMaterialGeometryControllerModule>;
}
export declare const NGT_MATERIAL_GEOMETRY_WATCHED_CONTROLLER: InjectionToken<NgtMaterialGeometryController>, NGT_MATERIAL_GEOMETRY_CONTROLLER_PROVIDER: import("@angular/core").Provider[];
