import { EventEmitter, NgZone, OnDestroy } from '@angular/core';
import * as THREE from 'three';
import { NgtEventsStore } from '../stores/events.store';
import { NgtInstancesStore } from '../stores/instances.store';
import { NgtStore } from '../stores/store';
import { NgtAnimationSubscriberController } from './animation-subscriber.controller';
import { Controller } from './controller';
import { NgtObject3dInputsController } from './object-3d-inputs.controller';
import * as i0 from "@angular/core";
export declare class NgtObject3dController extends Controller implements OnDestroy {
    #private;
    private store;
    private eventsStore;
    private instancesStore;
    private objectInputsController;
    private animationSubscriberController;
    private parentObject3d;
    ready: EventEmitter<void>;
    set initFn(v: () => THREE.Object3D);
    get initFn(): () => THREE.Object3D;
    constructor(ngZone: NgZone, store: NgtStore, eventsStore: NgtEventsStore, instancesStore: NgtInstancesStore, objectInputsController: NgtObject3dInputsController, animationSubscriberController: NgtAnimationSubscriberController, parentObject3d: NgtObject3dController);
    ngOnInit(): void;
    init(): void;
    ngOnDestroy(): void;
    get object3d(): THREE.Object3D;
    get controller(): Controller | undefined;
    get props(): string[];
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObject3dController, [null, null, null, null, null, null, { optional: true; skipSelf: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtObject3dController, "    ngt-primitive,    ngt-bone,    ngt-group,    ngt-lod,    ngt-points,    ngt-mesh,    ngt-instanced-mesh,    ngt-skinned-mesh,    ngt-audio,    ngt-positional-audio,    ngt-line,    ngt-line-loop,    ngt-line-segments,    ngt-light-probe,    ngt-ambient-light,    ngt-ambient-light-probe,    ngt-hemisphere-light,    ngt-hemisphere-light-probe,    ngt-directional-light,    ngt-point-light,    ngt-spot-light,    ngt-rect-area-light,    ngt-arrow-helper,    ngt-axes-helper,    ngt-box-helper,    ngt-box3-helper,    ngt-grid-helper,    ngt-camera-helper,    ngt-directional-light-helper,    ngt-hemisphere-light-helper,    ngt-plane-helper,    ngt-point-light-helper,    ngt-polar-grid-helper,    ngt-skeleton-helper,    ngt-spot-light-helper,    ngt-sprite,    ngt-camera,    ngt-perspective-camera,    ngt-orthographic-camera,    ngt-array-camera,    ngt-stereo-camera,    ngt-cube-camera  ", ["ngtObject3dController"], {}, { "ready": "ready"; }, never>;
}
export declare class NgtObject3dControllerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObject3dControllerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtObject3dControllerModule, [typeof NgtObject3dController], never, [typeof NgtObject3dController]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtObject3dControllerModule>;
}
export declare const NGT_OBJECT_WATCHED_CONTROLLER: import("@angular/core").InjectionToken<NgtObject3dController>, NGT_OBJECT_CONTROLLER_PROVIDER: import("@angular/core").Provider[];
